/**
 * @file  hwsetup.c
 * @brief n[hEFAZbgAbv
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2013
 */
/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/
#include <machine.h>
#include "iodefine.h"

/*----------------------------------------------------------------------
	萔`
----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
void HardwareSetup(void);
static void ClockInit( void );
static void SdramInit( void );
/*----------------------------------------------------------------------
	\[XR[h
----------------------------------------------------------------------*/
/** n[hEFAZbgAbv֐
 * @param void
 * @retval void
 */
void HardwareSetup(void)
{
	ClockInit();
#ifdef SDRAM
	SdramInit();
#endif
}

/** NbNݒ
 * @param void
 * @retval void
 */
static void ClockInit( void )
{
	// ̓NbN12MHz
	SYSTEM.SCKCR.BIT.ICK = 0 ;				// ICK:VXeNbN			= 12 * 8 = 96MHz
	SYSTEM.SCKCR.BIT.BCK = 2 ;				// BCK:OoXNbN			= 12 * 2 = 24MHz
	SYSTEM.SCKCR.BIT.PCK = 1 ;				// PCK:ӃW[NbN	= 12 * 4 = 48MHz
}

/** SDRAMݒ
 * @param void
 * @retval void
 */
static void SdramInit( void )
{
	SYSTEM.SYSCR0.WORD = 0x5A03;			// ROMLg[h

	/* SDRAM|[gݒ */
	SYSTEM.SCKCR.BIT.PSTOP0		= 1;		// ύXJn
	IOPORT.PF4BUS.BYTE			= 0xFF;		// A8`A15AhXo͋
	IOPORT.PF5BUS.BIT.DHE		= 1;		// PE0`PE7Of[^oXD8`D15ƂĐݒ
	IOPORT.PF6BUS.BIT.SDCLKE 	= 1;		// SDCLKo͗L
	IOPORT.PF6BUS.BIT.MDSDE		= 1;		// CKEASDCS#ARAS#ACAS#AWE#ADQM0o͗L
	IOPORT.PF6BUS.BIT.DQM1E		= 1;		// DQM1o͗L
	SYSTEM.SCKCR.BIT.PSTOP0 	= 0 ;		// ύXI

	/* V[PX */
	BSC.SDIR.BIT.PRC			= 0 ;		// v`[WTCNݒ
	BSC.SDIR.BIT.ARFC			= 2 ;		// I[gtbV
	BSC.SDIR.BIT.ARFI			= 1 ;		// I[gtbVԊu
	BSC.SDICR.BIT.INIRQ			= 1 ;		// V[PXJn

	/* SDRAMCݒ */
	while ( BSC.SDSR.BYTE != 0 );
	BSC.SDAMOD.BIT.BE			= 1 ;		// AANZX
	BSC.SDCCR.BIT.BSIZE			= 0 ;		// 16rbgoX
	BSC.SDMOD.BIT.MR			= 0 ;		// [hWX^R}hs
	BSC.SDTR.BIT.RAS			= 3 ;		// EANeBuԐݒ
	BSC.SDTR.BIT.RCD			= 2 ;		// EJCeVݒ
	BSC.SDTR.BIT.RP				= 1 ;		// Ev`[WԐݒ
	BSC.SDTR.BIT.WR				= 1 ;		// CgJoԐݒ
	BSC.SDTR.BIT.CL				= 2 ;		// SDRAMCJCeVݒ
	BSC.SDADR.BIT.MXC			= 1 ;		// AhX}`vNXI(9rbgVtg)

	/* I[gtbV̊Jn */
	BSC.SDRFCR.BIT.RFC			= 138 ;		// I[gtbVvԊu
	BSC.SDRFCR.BIT.REFW			= 2 ;		// tbVTCN
	BSC.SDRFEN.BIT.RFEN			= 1 ;		// RFENrbgg 1hɂ

	/* ANZX */
	BSC.SDCCR.BIT.EXENB			= 1 ;		// 싖
}

/* End of File */
